#include "integer.h"  
#include <avr/pgmspace.h> 


//----------------- Idmrs, stopper vltozk -----------
volatile BYTE rx_data;
//volatile BOOL fogadas=FALSE;
char buf[32];
volatile BYTE delta=0,pOCR=0;
volatile BYTE analog_timer=0,cm_timer=0,fek_timer=0;

volatile WORD step_db =0;
volatile BYTE akku_motor=200,akku_uc=200,blue_conn=0;
WORD motor_current=0,curr_db=0;
BYTE lampa=0;
BOOL stop = FALSE;


#define MAX_FIFO_BUFFER 			128
#define BLUE_SENTENCES_BUFFER 		128
volatile BYTE f_buffer[MAX_FIFO_BUFFER];

#define USART_BAUDRATE 19200 
#define UBRR_ERTEK ((F_CPU / (USART_BAUDRATE * 8UL)) - 1) // a 8 a 2x szeres sebessg miatt


// motor vezrl portok belltsa
#define M1A 		(1<<PD3)
#define M1A_DDR		DDRD
#define M1A_PORT	PORTD

#define M1B 		(1<<PD4)
#define M1B_DDR		DDRD
#define M1B_PORT	PORTD

#define MOTOR_STOP() 	M1A_DDR|=M1A;M1A_PORT&=~M1A;M1B_DDR|=M1B;M1B_PORT&=~M1B;
#define MOTOR_ELORE() 	M1A_DDR|=M1A;M1A_PORT|=M1A;M1B_DDR|=M1B;M1B_PORT&=~M1B;
#define MOTOR_HATRA() 	M1A_DDR|=M1A;M1A_PORT&=~M1A;M1B_DDR|=M1B;M1B_PORT|=M1B;

//az android bluetooth-tl rkrz parancsok definilsa

#define SERVO_STOP	 	 65 //#SS
#define SERVO_LEFT	 	 66 //#SL
#define SERVO_RIGHT 	 67	//#SR
#define DC_MOTOR_STOP    68 //#MS
#define DC_MOTOR_FOR 	 69 //#MF
#define DC_MOTOR_REW 	 70 //#MR
#define AKKU_UC_WORD	 71 //#A_UC
#define AKKU_MOTOR_WORD	 72 //#A_MO
#define DAC				 73 //#DAC
#define CURRENT_MOTOR	 74	//#I_MO
#define LAMPA			 75	//#LA
#define AUTO_STOP		 76	//#STOP
#define AUTO_ON 		 77	//#ON

#define SERVO_MIN		600
#define SERVO_MINUS45	1050
#define SERVO_MID		1600
#define SERVO_PLUS45	2050
#define SERVO_MAX		2600 

//ADC 
#define AKKU_MOTOR	 		3			//ADC3, PC2
#define AKKU_UC		 		7			//ADC7
#define BLUE_CONN			5			//ADC5	 
#define MOTOR_CURRENT		6			//ADC6
#define BLUE_CONNECT()		(blue_conn > 50) ? TRUE : FALSE

//Lmpk 
#define L_REF		(1<<PB6)
#define L_REF_DDR	DDRB
#define L_REF_PORT	PORTB

#define R_REF		(1<<PB7)
#define R_REF_DDR	DDRB
#define R_REF_PORT	PORTB

#define FEK_LAMP		(1<<PD2)
#define FEK_LAMP_DDR	DDRD
#define FEK_LAMP_PORT	PORTD

//over current limiter LED
#define OCL_LED			(1<<PB5)
#define OCL_LED_DDR		DDRB
#define OCL_LED_PORT	PORTB


#define LEFT_REFLEKTOR_ON		L_REF_DDR|=L_REF;L_REF_PORT|=L_REF
#define RIGHT_REFLEKTOR_ON  	R_REF_DDR|=R_REF;R_REF_PORT|=R_REF
#define RL_REFLEKTOR_ON			L_REF_DDR|=L_REF;L_REF_PORT|=L_REF;R_REF_DDR|=R_REF;R_REF_PORT|=R_REF
#define LEFT_REFLEKTOR_OFF		L_REF_DDR|=L_REF;L_REF_PORT&=~L_REF
#define RIGHT_REFLEKTOR_OFF		R_REF_DDR|=L_REF;R_REF_PORT&=~R_REF
#define RL_REFLEKTOR_OFF		L_REF_DDR|=L_REF;L_REF_PORT&=~L_REF;R_REF_DDR|=L_REF;R_REF_PORT&=~R_REF
#define LEFT_REFLEKTOR_CHANGE		L_REF_DDR|=L_REF;L_REF_PORT^=L_REF
#define RIGHT_REFLEKTOR_CHANGE  	R_REF_DDR|=R_REF;R_REF_PORT^=R_REF
#define RL_REFLEKTOR_CHANGE			L_REF_DDR|=L_REF;L_REF_PORT^=L_REF;R_REF_DDR|=R_REF;R_REF_PORT^=R_REF
#define FEK_LAMP_ON				FEK_LAMP_DDR|=FEK_LAMP;FEK_LAMP_PORT|=FEK_LAMP
#define FEK_LAMP_OFF			FEK_LAMP_DDR|=FEK_LAMP;FEK_LAMP_PORT&=~FEK_LAMP

#define OCL_LED_ON				OCL_LED_DDR|=OCL_LED;OCL_LED_PORT|=OCL_LED
#define OCL_LED_OFF				OCL_LED_DDR|=OCL_LED;OCL_LED_PORT&=~OCL_LED

#define DACDDR	DDRC
#define DACPORT	PORTC
#define DAC_OUT(num)	DACDDR|=(1<<PC2)|(1<<PC1)|(1<<PC0);DACPORT&=(0<<PC2)|(0<<PC1)|(0<<PC0);DACPORT|=((num&4)/4<<PC2)|((num&2)/2<<PC1)|(num&1<<PC0)

	#define DELTA			10

#define ANALOG_COMP_ENABLED   	ACSR&(1<<ACIE) ? TRUE : FALSE


BYTE gp_comp(const char *str1, const prog_char *str2);
